package fishrungames.bashgid;


import java.util.Locale;

import fishrungames.bashgid.core.NewsManager.NewsRecord;
import fishrungames.bashgid.core.db.NewsDataSource;
import android.support.v7.app.ActionBarActivity;
import android.support.v4.app.Fragment;
import android.content.res.Configuration;
import android.os.Bundle;

import android.view.Menu;
import android.view.MenuItem;
import android.view.View;

import android.support.v4.widget.DrawerLayout;




public class MainActivity extends ActionBarActivity 
implements NavigationDrawerFragment.NavigationDrawerCallbacks {

	
	public static final String TAG_FROM_MAINFRAGMENT_TO_NEWSRECORDFRAGMENT = "TAG_FROM_MAINFRAGMENT_TO_NEWSRECORDFRAGMENT";
	public static final String TAG_FROM_NEWSLISTFRAGMENT_TO_NEWSRECORDFRAGMENT = "TAG_FROM_NEWSLISTFRAGMENT_TO_NEWSRECORDFRAGMENT";
	
	static MainActivity instance = null;
	
	private NavigationDrawerFragment mNavigationDrawerFragment = null;
	
	public NewsDataSource newsDataSource;
	
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
  
        setContentView(R.layout.activity_main);
        
        SetupDrawer();
     
        getSupportFragmentManager().beginTransaction().add(R.id.fragment_container, new WelcomeFragment()).commit();
           
        instance = this;
        
        newsDataSource = new NewsDataSource(this);
        
        newsDataSource.open();

    }
        
    public static MainActivity getInstance()
    {
		return instance;
    	
    }
    
    
    public void OnSelectEnglish(View view)
	{
        Locale.setDefault(Locale.US);
        Configuration config = new Configuration();
        config.locale = Locale.US;
        getBaseContext().getResources().updateConfiguration(config, getBaseContext().getResources().getDisplayMetrics());
    	
        getSupportActionBar().setTitle(R.string.app_name);
        
        SetupDrawer();
        
		OpenMainScreen();
	}
	
	public void OnSelectRussian(View view)
	{
		Locale locale = new Locale("ru"); 
        Locale.setDefault(locale);
        Configuration config = new Configuration();
        config.locale = locale;
        getBaseContext().getResources().updateConfiguration(config, getBaseContext().getResources().getDisplayMetrics());
    	
        getSupportActionBar().setTitle(R.string.app_name);
        SetupDrawer();
        
		OpenMainScreen();
	}
	
	public void OnSelectChinese(View view)
	{
        Locale.setDefault(Locale.CHINA);
        Configuration config = new Configuration();
        config.locale = Locale.CHINA;
        getBaseContext().getResources().updateConfiguration(config, getBaseContext().getResources().getDisplayMetrics());
    	
        getSupportActionBar().setTitle(R.string.app_name);
        SetupDrawer();
        
		OpenMainScreen();
	}
	
	public void OnSelectSemiDetails(Integer pos)
	{
		//getSupportFragmentManager().beginTransaction().add(R.id.fragment_container, new SemiDetailsFragment()).addToBackStack(null).commit();
	}
	
	public void OpenMainScreen()
	{

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new MainPageFragment()).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}
	
	public void OpenNewsScreen()
	{

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new NewsListFragment()).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}
	
	public void OpenNewsRecordScreen(NewsRecord newsRecord, String tag)
	{
		//Xperimental -- addToBackStack provoke error "Class not found". Need to resolve somehow!
		//getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new NewsRecordFragment(newsRecord)).addToBackStack(null).commit();
		
		//I added workaround:
		
		NewsRecordFragment newsRecordFragment = new NewsRecordFragment(newsRecord);
		
		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, newsRecordFragment, tag).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}
	
	@Override
	public void onAttachFragment(Fragment fragment)
	{
		super.onAttachFragment(fragment);
		
	}
	
	public void SetupDrawer()
	{
	
	
		mNavigationDrawerFragment = (NavigationDrawerFragment)
				getSupportFragmentManager().findFragmentById(R.id.navigation_drawer);

		if (mNavigationDrawerFragment != null)
		{
		
        // Set up the drawer.
        mNavigationDrawerFragment.setUp(
                R.id.navigation_drawer,
                (DrawerLayout) findViewById(R.id.drawer_layout));
		}
	}

	

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }
    
    
    @Override
    public void onNavigationDrawerItemSelected(int position)
    {
    	if (position == 1)
    	{
    		OpenMainScreen();
    	}
    	else if (position == 2)
    	{
    		OpenNewsScreen();
    	}
    }

    
    
    @Override
    public void onBackPressed() {
    
        if ( getSupportFragmentManager().findFragmentByTag(TAG_FROM_MAINFRAGMENT_TO_NEWSRECORDFRAGMENT) != null)
        {
        	OpenMainScreen();
        	
        	return;
        }
        
        if ( getSupportFragmentManager().findFragmentByTag(TAG_FROM_NEWSLISTFRAGMENT_TO_NEWSRECORDFRAGMENT) != null)
        {
        	OpenNewsScreen();
        	
        	return;
        }
        
        super.onBackPressed();
    	
    	
    	/*
    	 * AddToBackStack is falling. Here is workaround
        if(getSupportFragmentManager().getBackStackEntryCount() != 0) {
        	getSupportFragmentManager().popBackStack();
        } else {
            super.onBackPressed();
        }*/
    }   
   
    @Override
    protected void onResume() {
    	//Xperimental -- opening and closing leads to fail
    	//newsDataSource.open();
      super.onResume();
    }

    @Override
    protected void onPause() {
    	//Xperimental -- opening and closing leads to fail
    	//newsDataSource.close();
      super.onPause();
    }


}
